Stock Performance Grid in JavaScript

Using ApexCharts with JavaScript

This Stock Performance Grid example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Six tickers whose price levels differ by 40x: a shared y scale would
// flatten the cheap ones into noise, so this trellis uses
// `scales: { y: 'independent' }`. Each panel gets its own honest domain, and
// the panels are STILL pixel-aligned: the trellis measures every panel's
// axis-label gutter and pushes the widest as a shared floor, so the plot
// rectangles agree to the pixel and the shapes stay comparable.
//
// One toolbar for the grid: drag or wheel-zoom in any panel and every panel
// follows on the shared x window; reset restores all six at once.
//
// Deterministic OHLC walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function ohlcWalk(seed, start, vol) {
  var rand = mulberry32(seed)
  var r2 = function (v) {
    return Math.round(v * 100) / 100
  }
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var close = start
  for (var i = 0; i < 40; i++) {
    var open = close
    close = Math.max(vol, open + (rand() - 0.48) * vol * 2)
    var high = Math.max(open, close) + rand() * vol
    var low = Math.max(vol * 0.2, Math.min(open, close) - rand() * vol)
    out.push({ x: ts, y: [r2(open), r2(high), r2(low), r2(close)] })
    ts += 86400000
  }
  return out
}

var TICKERS = [
  { ticker: 'ANVL', seed: 3, start: 24, vol: 0.9 },
  { ticker: 'BRCK', seed: 17, start: 61, vol: 2.1 },
  { ticker: 'CDER', seed: 29, start: 142, vol: 4.5 },
  { ticker: 'DELM', seed: 41, start: 310, vol: 9 },
  { ticker: 'ELMS', seed: 53, start: 78, vol: 2.6 },
  { ticker: 'FRST', seed: 67, start: 927, vol: 24 },
]

// One series NAME across the grid (the headers already name the tickers), so
// the shared legend has nothing to add and stays hidden.
var stockSeries = TICKERS.map(function (t) {
  return {
    name: 'OHLC',
    ticker: t.ticker,
    data: ohlcWalk(t.seed, t.start, t.vol),
  }
})

var options = {
  series: stockSeries,
  chart: {
    id: 'stockTrellis',
    type: 'candlestick',
    height: 620,
    animations: {
      enabled: false,
    },
  },
  trellis: {
    by: 'ticker',
    columns: 3,
    gap: 14,
    scales: {
      y: 'independent',
    },
  },
  xaxis: {
    type: 'datetime',
  },
  yaxis: {
    labels: {
      formatter: function (val) {
        return '$' + Math.round(val)
      },
    },
  },
  dataLabels: {
    enabled: false,
  },
  tooltip: {
    x: {
      format: 'dd MMM',
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Stock Performance Grid in Vue

Using ApexCharts with Vue

This Stock Performance Grid example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Six tickers, one grid</h1>
      <p class="lead">
        Price levels 40x apart, so each panel keeps its own y scale, yet all six
        plot rectangles are pixel-identical. Zoom anywhere: every ticker follows
        on the same date window, and one reset brings them all back.
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="candlestick"
            height="620"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="note">
        <code>scales.y: 'independent'</code> gives every ticker its own domain
        (a $24 stock and a $900 stock cannot share an axis honestly), and an
        independent scale draws its own labels on every panel. The panels stay
        aligned anyway: the trellis measures each panel's label gutter and
        pushes the widest as a shared <code>yaxis.labels.minWidth</code>, so
        shapes compare cleanly across the grid. The x window is shared:
        drag-zoom any panel and the whole grid moves; the single toolbar's reset
        restores it. Trellis is a premium feature; without a license it renders
        with a trial watermark.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/features/trellis'

// Six tickers whose price levels differ by 40x: a shared y scale would
// flatten the cheap ones into noise, so this trellis uses
// `scales: { y: 'independent' }`. Each panel gets its own honest domain, and
// the panels are STILL pixel-aligned: the trellis measures every panel's
// axis-label gutter and pushes the widest as a shared floor, so the plot
// rectangles agree to the pixel and the shapes stay comparable.
//
// One toolbar for the grid: drag or wheel-zoom in any panel and every panel
// follows on the shared x window; reset restores all six at once.
//
// Deterministic OHLC walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function ohlcWalk(seed, start, vol) {
  var rand = mulberry32(seed)
  var r2 = function (v) {
    return Math.round(v * 100) / 100
  }
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var close = start
  for (var i = 0; i < 40; i++) {
    var open = close
    close = Math.max(vol, open + (rand() - 0.48) * vol * 2)
    var high = Math.max(open, close) + rand() * vol
    var low = Math.max(vol * 0.2, Math.min(open, close) - rand() * vol)
    out.push({ x: ts, y: [r2(open), r2(high), r2(low), r2(close)] })
    ts += 86400000
  }
  return out
}

var TICKERS = [
  { ticker: 'ANVL', seed: 3, start: 24, vol: 0.9 },
  { ticker: 'BRCK', seed: 17, start: 61, vol: 2.1 },
  { ticker: 'CDER', seed: 29, start: 142, vol: 4.5 },
  { ticker: 'DELM', seed: 41, start: 310, vol: 9 },
  { ticker: 'ELMS', seed: 53, start: 78, vol: 2.6 },
  { ticker: 'FRST', seed: 67, start: 927, vol: 24 },
]

// One series NAME across the grid (the headers already name the tickers), so
// the shared legend has nothing to add and stays hidden.
var stockSeries = TICKERS.map(function (t) {
  return {
    name: 'OHLC',
    ticker: t.ticker,
    data: ohlcWalk(t.seed, t.start, t.vol),
  }
})

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: stockSeries,
      chartOptions: {
        chart: {
          id: 'stockTrellis',
          type: 'candlestick',
          height: 620,
          animations: {
            enabled: false,
          },
        },
        trellis: {
          by: 'ticker',
          columns: 3,
          gap: 14,
          scales: {
            y: 'independent',
          },
        },
        xaxis: {
          type: 'datetime',
        },
        yaxis: {
          labels: {
            formatter: function (val) {
              return '$' + Math.round(val)
            },
          },
        },
        dataLabels: {
          enabled: false,
        },
        tooltip: {
          x: {
            format: 'dd MMM',
          },
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 1040px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
.lead {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 20px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  background: #fffbeb;
  border-left: 3px solid #d97706;
  padding: 12px 16px;
  font-size: 13px;
  color: #333;
  border-radius: 2px;
  line-height: 1.6;
  margin: 26px auto 0;
}
.note code {
  background: #fef3c7;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>

Stock Performance Grid in React

Using ApexCharts with React

This Stock Performance Grid example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/features/trellis'

// Six tickers whose price levels differ by 40x: a shared y scale would
// flatten the cheap ones into noise, so this trellis uses
// `scales: { y: 'independent' }`. Each panel gets its own honest domain, and
// the panels are STILL pixel-aligned: the trellis measures every panel's
// axis-label gutter and pushes the widest as a shared floor, so the plot
// rectangles agree to the pixel and the shapes stay comparable.
//
// One toolbar for the grid: drag or wheel-zoom in any panel and every panel
// follows on the shared x window; reset restores all six at once.
//
// Deterministic OHLC walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function ohlcWalk(seed, start, vol) {
  var rand = mulberry32(seed)
  var r2 = function (v) {
    return Math.round(v * 100) / 100
  }
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var close = start
  for (var i = 0; i < 40; i++) {
    var open = close
    close = Math.max(vol, open + (rand() - 0.48) * vol * 2)
    var high = Math.max(open, close) + rand() * vol
    var low = Math.max(vol * 0.2, Math.min(open, close) - rand() * vol)
    out.push({ x: ts, y: [r2(open), r2(high), r2(low), r2(close)] })
    ts += 86400000
  }
  return out
}

var TICKERS = [
  { ticker: 'ANVL', seed: 3, start: 24, vol: 0.9 },
  { ticker: 'BRCK', seed: 17, start: 61, vol: 2.1 },
  { ticker: 'CDER', seed: 29, start: 142, vol: 4.5 },
  { ticker: 'DELM', seed: 41, start: 310, vol: 9 },
  { ticker: 'ELMS', seed: 53, start: 78, vol: 2.6 },
  { ticker: 'FRST', seed: 67, start: 927, vol: 24 },
]

// One series NAME across the grid (the headers already name the tickers), so
// the shared legend has nothing to add and stays hidden.
var stockSeries = TICKERS.map(function (t) {
  return {
    name: 'OHLC',
    ticker: t.ticker,
    data: ohlcWalk(t.seed, t.start, t.vol),
  }
})

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: stockSeries,
    options: {
      chart: {
        id: 'stockTrellis',
        type: 'candlestick',
        height: 620,
        animations: {
          enabled: false,
        },
      },
      trellis: {
        by: 'ticker',
        columns: 3,
        gap: 14,
        scales: {
          y: 'independent',
        },
      },
      xaxis: {
        type: 'datetime',
      },
      yaxis: {
        labels: {
          formatter: function (val) {
            return '$' + Math.round(val)
          },
        },
      },
      dataLabels: {
        enabled: false,
      },
      tooltip: {
        x: {
          format: 'dd MMM',
        },
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>Six tickers, one grid</h1>
        <p className="lead">
          Price levels 40x apart, so each panel keeps its own y scale, yet all
          six plot rectangles are pixel-identical. Zoom anywhere: every ticker
          follows on the same date window, and one reset brings them all back.
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="candlestick"
              height={620}
            />
          </div>
        </div>

        <div className="note">
          <code>scales.y: 'independent'</code> gives every ticker its own domain
          (a $24 stock and a $900 stock cannot share an axis honestly), and an
          independent scale draws its own labels on every panel. The panels stay
          aligned anyway: the trellis measures each panel's label gutter and
          pushes the widest as a shared <code>yaxis.labels.minWidth</code>, so
          shapes compare cleanly across the grid. The x window is shared:
          drag-zoom any panel and the whole grid moves; the single toolbar's
          reset restores it. Trellis is a premium feature; without a license it
          renders with a trial watermark.
        </div>
      </div>
    </div>
  )
}

export default ApexChart

Stock Performance Grid in Angular

Using ApexCharts with Angular

This Stock Performance Grid example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (seed: any): any => {
        return function () {
          seed |= 0
          seed = (seed + 0x6d2b79f5) | 0
          var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
          t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
          return ((t ^ (t >>> 14)) >>> 0) / 4294967296
        }
      };

  private ohlcWalk = (seed: any, start: any, vol: any): any => {
        var rand = this.mulberry32(seed)
        var r2 = function (v) {
          return Math.round(v * 100) / 100
        }
        var out = []
        var ts = new Date('01 Jan 2025').getTime()
        var close = start
        for (var i = 0; i < 40; i++) {
          var open = close
          close = Math.max(vol, open + (rand() - 0.48) * vol * 2)
          var high = Math.max(open, close) + rand() * vol
          var low = Math.max(vol * 0.2, Math.min(open, close) - rand() * vol)
          out.push({ x: ts, y: [r2(open), r2(high), r2(low), r2(close)] })
          ts += 86400000
        }
        return out
      };

  private TICKERS: any = [
        { ticker: 'ANVL', seed: 3, start: 24, vol: 0.9 },
        { ticker: 'BRCK', seed: 17, start: 61, vol: 2.1 },
        { ticker: 'CDER', seed: 29, start: 142, vol: 4.5 },
        { ticker: 'DELM', seed: 41, start: 310, vol: 9 },
        { ticker: 'ELMS', seed: 53, start: 78, vol: 2.6 },
        { ticker: 'FRST', seed: 67, start: 927, vol: 24 },
      ];

  private stockSeries: any = this.TICKERS.map(function (t) {
        return {
          name: 'OHLC',
          ticker: t.ticker,
          data: this.ohlcWalk(t.seed, t.start, t.vol),
        }
      });

  public chartOptions: Partial<ChartOptions> = {
          series: this.stockSeries,
          chart: {
            id: 'stockTrellis',
            type: 'candlestick',
            height: 620,
            animations: {
              enabled: false,
            },
          },
          trellis: {
            by: 'ticker',
            columns: 3,
            gap: 14,
            scales: {
              y: 'independent',
            },
          },
          xaxis: {
            type: 'datetime',
          },
          yaxis: {
            labels: {
              formatter: (val) => {
                return '$' + Math.round(val)
              },
            },
          },
          dataLabels: {
            enabled: false,
          },
          tooltip: {
            x: {
              format: 'dd MMM',
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}